## iddawc 1.1.6

=== CMakeLists.txt ===
#
# Iddawc library
#
# CMake file used to build all programs
#
# Copyright 2018 Silvio Clecio <silvioprog@gmail.com>
# Copyright 2019-2022 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the MIT License
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#

cmake_minimum_required(VERSION 3.5)

project(iddawc C)

set(CMAKE_C_STANDARD 99)
if (NOT MSVC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror")
endif()

# library info

set(PROJECT_DESCRIPTION "OAuth2/OIDC client library")
set(PROJECT_HOMEPAGE_URL "https://github.com/babelouest/iddawc/")
set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/iddawc/issues")
set(LIBRARY_VERSION_MAJOR "1")
set(LIBRARY_VERSION_MINOR "1")
set(LIBRARY_VERSION_PATCH "6")
set(ORCANIA_VERSION_REQUIRED "2.3.0")
set(YDER_VERSION_REQUIRED "1.4.17")
set(ULFIUS_VERSION_REQUIRED "2.7.10")
set(RHONABWY_VERSION_REQUIRED "1.1.8")

set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
set(PROJECT_VERSION_MINOR ${LIBRARY_VERSION_MINOR})
set(PROJECT_VERSION_PATCH ${LIBRARY_VERSION_PATCH})

if (${LIBRARY_VERSION_MAJOR} VERSION_LESS 10)
    set (LIBRARY_VERSION_MAJOR_PAD "0${LIBRARY_VERSION_MAJOR}")
else ()
    set (LIBRARY_VERSION_MAJOR_PAD "${LIBRARY_VERSION_MAJOR}")
endif ()
if (${LIBRARY_VERSION_MINOR} VERSION_LESS 10)
    set (LIBRARY_VERSION_MINOR_PAD "0${LIBRARY_VERSION_MINOR}")
else ()
    set (LIBRARY_VERSION_MINOR_PAD "${LIBRARY_VERSION_MINOR}")
endif ()
if (${LIBRARY_VERSION_PATCH} VERSION_LESS 10)
    set (LIBRARY_VERSION_PATCH_PAD "0${LIBRARY_VERSION_PATCH}")
else ()
    set (LIBRARY_VERSION_PATCH_PAD "${LIBRARY_VERSION_PATCH}")
endif ()
set(PROJECT_VERSION_NUMBER "${LIBRARY_VERSION_MAJOR_PAD}${LIBRARY_VERSION_MINOR_PAD}${LIBRARY_VERSION_PATCH_PAD}")

set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(LIBRARY_SOVERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")

# cmake modules

set(I_CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake-modules)
list(APPEND CMAKE_MODULE_PATH "${I_CMAKE_MODULE_PATH}")

set(IDWCC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/tools/idwcc)

include(GNUInstallDirs)
include(CheckSymbolExists)

# check if _GNU_SOURCE is available

if (NOT _GNU_SOURCE)
    check_symbol_exists(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)

    if (NOT _GNU_SOURCE)
        unset(_GNU_SOURCE CACHE)
        check_symbol_exists(_GNU_SOURCE "features.h" _GNU_SOURCE)
    endif ()
endif ()

if (_GNU_SOURCE)
    add_definitions(-D_GNU_SOURCE)
endif ()

# directories and source

set(INC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)

include_directories(${INC_DIR})

set(LIB_SRC
        ${INC_DIR}/iddawc.h # allow many IDEs to find and edit it
        ${SRC_DIR}/iddawc.c)

set(PKGCONF_REQ "")
set(PKGCONF_REQ_PRIVATE "")

# static library

option(BUILD_STATIC "Build static library." OFF)

if (BUILD_STATIC)
    add_library(iddawc_static STATIC ${LIB_SRC})
    target_compile_definitions(iddawc_static PUBLIC -DO_STATIC_LIBRARY)
    set_target_properties(iddawc_static PROPERTIES
            OUTPUT_NAME iddawc)
endif ()

# shared library

add_library(iddawc SHARED ${LIB_SRC})
set_target_properties(iddawc PROPERTIES
        COMPILE_OPTIONS -Wextra
        PUBLIC_HEADER "${INC_DIR}/iddawc.h;${PROJECT_BINARY_DIR}/iddawc-cfg.h"
        VERSION "${LIBRARY_VERSION}"
        SOVERSION "${LIBRARY_SOVERSION}")

include(FindJansson)
set(JANSSON_MIN_VERSION 2.11)
find_package(Jansson ${JANSSON_MIN_VERSION} REQUIRED)
if (JANSSON_FOUND)
	set(LIBS ${LIBS} ${JANSSON_LIBRARIES})
	include_directories(${JANSSON_INCLUDE_DIRS})
endif ()

include(FindNettle)
find_package(Nettle REQUIRED)
if (NETTLE_FOUND)
	set(LIBS ${LIBS} ${NETTLE_LIBRARIES})
	include_directories(${NETTLE_INCLUDE_DIRS})
endif ()

include(FindGnuTLS)
find_package(GnuTLS REQUIRED)
if (GNUTLS_FOUND)
	set(LIBS ${LIBS} ${GNUTLS_LIBRARIES})
	include_directories(${GNUTLS_INCLUDE_DIRS})
endif ()
target_link_libraries(iddawc ${LIBS})

include(FindMHD)
find_package(MHD REQUIRED)

set(SEARCH_ORCANIA OFF CACHE BOOL "Force to false") # Avoid to search and download orcania
set(SEARCH_ORCANIA_U OFF CACHE BOOL "Force to false") # Avoid to search and download orcania
set(SEARCH_YDER OFF CACHE BOOL "Force to false") # Avoid to search and download yder during
set(SEARCH_ORCANIA_R OFF CACHE BOOL "Force to false") # Avoid to search and download orcania during
set(SEARCH_YDER_R OFF CACHE BOOL "Force to false") # Avoid to search and download yder during
set(SEARCH_ULFIUS_R OFF CACHE BOOL "Force to false") # Avoid to search and download ulfius during

option(DOWNLOAD_DEPENDENCIES "Download required dependencies" ON)

option(SEARCH_ORCANIA_I "Search for ORCANIA library" ON)
if (SEARCH_ORCANIA_I)
    set(Orcania_FIND_QUIETLY ON) # force to find Orcania quietly
    include(FindOrcania)
    find_package(Orcania ${ORCANIA_VERSION_REQUIRED} QUIET) # try to find orcania
    if (NOT ORCANIA_FOUND)
        if (DOWNLOAD_DEPENDENCIES)
            include(DownloadProject)
            message(STATUS "Download Orcania ${ORCANIA_VERSION_REQUIRED}")
            download_project(PROJ orcania # ... otherwise, download archive
                    URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_REQUIRED}.tar.gz"
                    QUIET)
            add_subdirectory(${orcania_SOURCE_DIR} ${orcania_BINARY_DIR})
            include_directories(${orcania_SOURCE_DIR}/include)
            add_dependencies(iddawc orcania)
            set(ORCANIA_LIBRARIES orcania)
            include_directories(${orcania_BINARY_DIR})
        else ()
            message( FATAL_ERROR "Orcania not found")
        endif ()
    else ()
        include_directories(${ORCANIA_INCLUDE_DIRS})
    endif ()
endif ()
target_link_libraries(iddawc ${ORCANIA_LIBRARIES})
set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})

option(SEARCH_YDER_I "Search for Yder library" ON)
if (SEARCH_YDER_I)
    set(Yder_FIND_QUIETLY ON) # force to find Yder quietly
    include(FindYder)
    find_package(Yder ${YDER_VERSION_REQUIRED} QUIET) # try to find Yder
    if (NOT YDER_FOUND)
        if (DOWNLOAD_DEPENDENCIES)
            include(DownloadProject)
            message(STATUS "Download Yder ${YDER_VERSION_REQUIRED}")
            option(CHECK_ORCANIA "specific param" off)
            download_project(PROJ yder # ... otherwise, download archive
                    URL "https://github.com/babelouest/yder/archive/v${YDER_VERSION_REQUIRED}.tar.gz"
                    QUIET)
            add_subdirectory(${yder_SOURCE_DIR} ${yder_BINARY_DIR})
            include_directories(${yder_SOURCE_DIR}/include)
            include_directories(${orcania_SOURCE_DIR}/include)
            add_dependencies(iddawc yder)
            set(YDER_LIBRARIES yder)
            include_directories(${yder_BINARY_DIR})
        else ()
            message( FATAL_ERROR "Yder not found")
        endif ()
    else ()
        include_directories(${YDER_INCLUDE_DIRS})
    endif ()
endif ()
target_link_libraries(iddawc ${YDER_LIBRARIES})
set(LIBS ${LIBS} ${YDER_LIBRARIES})

option(SEARCH_ULFIUS_I "Search for Ulfius library" ON)
if (SEARCH_ULFIUS_I)
    set(Ulfius_FIND_QUIETLY ON)
    include(FindUlfius)
    find_package(Ulfius ${ULFIUS_VERSION_REQUIRED} QUIET)
    if (NOT ULFIUS_FOUND)
        if (DOWNLOAD_DEPENDENCIES)
            include(DownloadProject)
            option(CHECK_ORCANIA "specific param" off)
            option(CHECK_YDER "specific param" off)
            message(STATUS "Download Ulfius ${ULFIUS_VERSION_REQUIRED}")
            download_project(PROJ ulfius
                    URL "https://github.com/babelouest/ulfius/archive/v${ULFIUS_VERSION_REQUIRED}.tar.gz"
                    QUIET)
            add_subdirectory(${ulfius_SOURCE_DIR} ${ulfius_BINARY_DIR})
            include_directories(${yder_SOURCE_DIR}/include)
            include_directories(${orcania_SOURCE_DIR}/include)
            include_directories(${ulfius_SOURCE_DIR}/include)
            add_dependencies(iddawc ulfius)
            set(ULFIUS_LIBRARIES ulfius)
            include_directories(${ulfius_BINARY_DIR})
        else ()
            message( FATAL_ERROR "Ulfius not found")
        endif ()
    else ()
        include_directories(${ULFIUS_INCLUDE_DIRS})
    endif ()
endif ()
target_link_libraries(iddawc ${ULFIUS_LIBRARIES})
set(LIBS ${LIBS} ${ULFIUS_LIBRARIES})

option(SEARCH_RHONABWY_I "Search for Rhonabwy library" ON)
if (SEARCH_RHONABWY_I)
    set(Rhonabwy_FIND_QUIETLY ON)
    include(FindRhonabwy)
    find_package(Rhonabwy ${RHONABWY_VERSION_REQUIRED} QUIET)
    if (NOT RHONABWY_FOUND)
        if (DOWNLOAD_DEPENDENCIES)
            include(DownloadProject)
            option(CHECK_ORCANIA "specific param" off)
            option(CHECK_YDER "specific param" off)
            option(CHECK_ULFIUS "specific param" off)
            message(STATUS "Download Rhonabwy ${RHONABWY_VERSION_REQUIRED}")
            download_project(PROJ rhonabwy
                    URL "https://github.com/babelouest/rhonabwy/archive/v${RHONABWY_VERSION_REQUIRED}.tar.gz"
                    QUIET)
            add_subdirectory(${rhonabwy_SOURCE_DIR} ${rhonabwy_BINARY_DIR})
            include_directories(${yder_SOURCE_DIR}/include)
            include_directories(${orcania_SOURCE_DIR}/include)
            include_directories(${ulfius_SOURCE_DIR}/include)
            include_directories(${rhonabwy_SOURCE_DIR}/include)
            add_dependencies(iddawc rhonabwy)
            set(RHONABWY_LIBRARIES rhonabwy)
            include_directories(${rhonabwy_BINARY_DIR})
        else ()
            message( FATAL_ERROR "Rhonabwy not found")
        endif ()
    else ()
        include_directories(${RHONABWY_INCLUDE_DIRS})
    endif ()
endif ()
target_link_libraries(iddawc ${RHONABWY_LIBRARIES})
set(LIBS ${LIBS} ${RHONABWY_LIBRARIES})

# build idwcc

option(BUILD_IDWCC "Build idwcc application." ON)

if (BUILD_IDWCC)
    find_package(Threads REQUIRED)
    set(LIBS ${LIBS} ${CMAKE_THREAD_LIBS_INIT})
    include(FindZLIB)
    find_package(ZLIB REQUIRED)
    if (ZLIB_FOUND)
      set(LIBS ${LIBS} ${ZLIB_LIBRARIES})
      include_directories(${ZLIB_INCLUDE_DIRS})
    endif ()
    add_executable(idwcc ${IDWCC_DIR}/idwcc.c ${INC_DIR}/iddawc.h ${IDWCC_DIR}/http_compression_callback.c ${IDWCC_DIR}/http_compression_callback.h ${IDWCC_DIR}/static_compressed_inmemory_website_callback.c ${IDWCC_DIR}/static_compressed_inmemory_website_callback.h ${PROJECT_BINARY_DIR}/iddawc-cfg.h)
    set_target_properties(idwcc PROPERTIES SKIP_BUILD_RPATH TRUE)
    add_dependencies(idwcc iddawc)
    target_link_libraries(idwcc iddawc ${LIBS})
    install(TARGETS idwcc RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
    install(FILES ${IDWCC_DIR}/idwcc.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 COMPONENT runtime)
    install(DIRECTORY ${IDWCC_DIR}/webapp/ DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/idwcc/webapp/ COMPONENT runtime)
endif ()

# documentation

option(BUILD_IDDAWC_DOCUMENTATION "Build the documentation." OFF)
if (BUILD_IDDAWC_DOCUMENTATION)
    find_package(Doxygen)
    if (DOXYGEN_FOUND)
        set(doxyfile_in ${CMAKE_CURRENT_SOURCE_DIR}/doc/doxygen.cfg)
        set(doxyfile ${CMAKE_CURRENT_BINARY_DIR}/doxyfile)
        
        configure_file(${doxyfile_in} ${doxyfile} @ONLY)
        
        add_custom_target(doc
                          COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile_in}
                          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                          COMMENT "Generating documentation with Doxygen"
                          VERBATIM)

    else ()
        message(FATAL_ERROR "Doxygen is needed to build the documentation.")
    endif ()
endif ()

# build iddawc-cfg.h file

=== Makefile ===
#
# Iddawc library
#
# Makefile used to build all programs
#
# Copyright 2020-2022 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#

LIBIDDAWC_LOCATION=./src
IDWCC_LOCATION=./tools/idwcc
TESTS_LOCATION=./test

all:
	cd $(LIBIDDAWC_LOCATION) && $(MAKE) $*
	cd $(IDWCC_LOCATION) && $(MAKE) $*

debug:
	cd $(LIBIDDAWC_LOCATION) && $(MAKE) debug $*

clean:
	cd $(LIBIDDAWC_LOCATION) && $(MAKE) clean
	cd $(IDWCC_LOCATION) && $(MAKE) clean
	cd $(TESTS_LOCATION) && $(MAKE) clean
	rm -rf doc/html $(TESTS_LOCATION)/cert/*.crt $(TESTS_LOCATION)/cert/*.key $(TESTS_LOCATION)/cert/*.log

install:
	cd $(LIBIDDAWC_LOCATION) && $(MAKE) install
	cd $(IDWCC_LOCATION) && $(MAKE) install

uninstall:
	cd $(LIBIDDAWC_LOCATION) && $(MAKE) uninstall
	cd $(IDWCC_LOCATION) && $(MAKE) uninstall

check:
	cd $(TESTS_LOCATION) && $(MAKE)

doxygen:
	doxygen doc/doxygen.cfg

=== src/Makefile ===
#
# Iddawc Library
#
# Makefile used to build the software
#
# Copyright 2019-2022 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation;
# version 2.1 of the License.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library.	If not, see <http://www.gnu.org/licenses/>.
#
PROJECT_NAME=iddawc
PROJECT_DESCRIPTION=OAuth2-OIDC client library
PROJECT_BUGREPORT_PATH=https://github.com/babelouest/iddawc/issues
PKGCONF_REQ=
PKGCONF_REQ_PRIVATE=
IDDAWC_INCLUDE=../include
PKGCONFIG_FILE=../libiddawc.pc
PKGCONFIG_TEMPLATE=../libiddawc.pc.in
CONFIG_FILE=$(IDDAWC_INCLUDE)/iddawc-cfg.h
CONFIG_TEMPLATE=$(IDDAWC_INCLUDE)/iddawc-cfg.h.in
DESTDIR=/usr/local
CC=gcc
CFLAGS+=-c -pedantic -std=gnu99 -fPIC -Wall -Werror -Wextra -D_REENTRANT -I$(IDDAWC_INCLUDE) $(ADDITIONALFLAGS) $(CPPFLAGS)
LIBS=-L$(DESTDIR)/lib -lc -lulfius -lyder -lorcania -lrhonabwy -lgnutls -ljansson $(LDFLAGS)
SONAME=-soname
OBJECTS=iddawc.o
OUTPUT=libiddawc.so
VERSION_MAJOR=1
VERSION_MINOR=1
VERSION_PATCH=6

.PHONY: all clean

all: release

$(CONFIG_FILE):
	@cp $(CONFIG_TEMPLATE) $(CONFIG_FILE)
	@echo Config file $(CONFIG_FILE) generated
	@sed -i -e 's/$${PROJECT_VERSION}/$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_MAJOR}/$(VERSION_MAJOR)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_MINOR}/$(VERSION_MINOR)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_PATCH}/$(VERSION_PATCH)/g' $(CONFIG_FILE)        
	@sed -i -e 's/$${PROJECT_VERSION_NUMBER}/$(shell printf '%02d' $(VERSION_MAJOR))$(shell printf '%02d' $(VERSION_MINOR))$(shell printf '%02d' $(VERSION_PATCH))/g' $(CONFIG_FILE)        

$(PKGCONFIG_FILE):
	@cp $(PKGCONFIG_TEMPLATE) $(PKGCONFIG_FILE)
	@echo Pkgconfig file $(PKGCONFIG_FILE) generated
	@sed -i -e 's#@CMAKE_INSTALL_PREFIX@#$(DESTDIR)#g' $(PKGCONFIG_FILE)
	@sed -i -e 's#@PKGCONFIG_TARGET_LIBDIR@#$${prefix}/lib#g' $(PKGCONFIG_FILE)
	@sed -i -e 's#@PKGCONFIG_TARGET_INCLUDES@#$${prefix}/include#g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PROJECT_NAME@/$(PROJECT_NAME)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PROJECT_DESCRIPTION@/$(PROJECT_DESCRIPTION)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's|@PROJECT_BUGREPORT_PATH@|$(PROJECT_BUGREPORT_PATH)|g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@LIBRARY_VERSION@/$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PKGCONF_REQ@/$(PKGCONF_REQ)/g' $(PKGCONFIG_FILE)
	@sed -i -e 's/@PKGCONF_REQ_PRIVATE@/$(PKGCONF_REQ_PRIVATE)/g' $(PKGCONFIG_FILE)

target: $(OBJECTS)

%.o: %.c $(CONFIG_FILE) $(IDDAWC_INCLUDE)/iddawc.h
	$(CC) $(CFLAGS) $<

libiddawc.so: $(CONFIG_FILE) $(PKGCONFIG_FILE) $(OBJECTS)
	$(CC) -shared -fPIC -Wl,$(SONAME),$(OUTPUT) -o $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(OBJECTS) $(LIBS) $(LYDER) $(LJANSSON) $(LCURL) $(LGNUTLS)
	ln -sf $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(OUTPUT)

clean:
	rm -f *.o *.so *.a $(OUTPUT) $(OUTPUT).* $(CONFIG_FILE) $(PKGCONFIG_FILE) $(CONFIG_FILE)

install: all $(PKGCONFIG_FILE)
	install $(OUTPUT).$(VERSION_MAJOR).$(VERSION_MINOR).$(VERSION_PATCH) $(DESTDIR)/lib
	mkdir -p $(DESTDIR)/lib/pkgconfig/ $(DESTDIR)/include
	install -m644 $(PKGCONFIG_FILE) $(DESTDIR)/lib/pkgconfig/
	install -m644 $(IDDAWC_INCLUDE)/iddawc.h $(DESTDIR)/include
	install -m644 $(CONFIG_FILE) $(DESTDIR)/include
	-ldconfig $(DESTDIR)/lib

uninstall:
	rm -f $(DESTDIR)/lib/$(OUTPUT) $(DESTDIR)/lib/libiddawc.a
	rm -f $(DESTDIR)/lib/$(OUTPUT).*
	rm -f $(DESTDIR)/include/iddawc.h
	rm -f $(DESTDIR)/include/$(CONFIG_FILE)
	rm -f $(DESTDIR)/lib/pkgconfig/$(PKGCONFIG_FILE)

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

debug: libiddawc.so

release: ADDITIONALFLAGS=-O3

release: libiddawc.so

=== tools/idwcc/Makefile ===
#
# idwcc: OAuth2/OIDC client program to test or validate OAuth2/OIDC AS
#
# Makefile used to build the software
#
# Copyright 2021 Nicolas Mora <mail@babelouest.org>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU GENERAL PUBLIC LICENSE
# License as published by the Free Software Foundation;
# version 3 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU GENERAL PUBLIC LICENSE for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
CC=gcc
IDDAWC_INCLUDE=../../include
IDDAWC_LOCATION=../../src
DESTDIR=/usr/local
IDDAWC_LIBRARY=../../src/libiddawc.so
IDDAWC_VERSION=$(shell curl -s https://api.github.com/repos/babelouest/iddawc/releases/latest | grep tag_name | cut -d '"' -f 4 | cut -c 2-)
ALPINE_VERSION=3.15.4

CFLAGS+=-c -Wall -I$(IDDAWC_INCLUDE) $(ADDITIONALFLAGS) $(CPPFLAGS) -DWEBAPP_PATH=\"$(DESTDIR)/share/idwcc/webapp/\"
LIBS=-lc -liddawc -L$(IDDAWC_LOCATION) $(shell pkg-config --libs liborcania) $(shell pkg-config --libs libyder) $(shell pkg-config --libs libulfius) $(shell pkg-config --libs jansson) -lpthread -lz
VALGRIND_COMMAND=valgrind --tool=memcheck --leak-check=full --show-leak-kinds=all --track-origins=yes
OBJECTS=idwcc.o static_compressed_inmemory_website_callback.o http_compression_callback.o

all: idwcc

all: ADDITIONALFLAGS= -O3

clean:
	rm -f *.o idwcc
	rm -f iddawc-dev-full_*_alpine_*_x86_64.tar.gz
	docker rmi -f babelouest/idwcc:latest babelouest/idwcc:$(IDDAWC_VERSION)
	docker system prune -f

debug: idwcc

debug: ADDITIONALFLAGS=-DDEBUG -g -O0

$(IDDAWC_LIBRARY): $(IDDAWC_INCLUDE)/iddawc.h $(IDDAWC_LOCATION)/iddawc.c
	cd $(IDDAWC_LOCATION) && $(MAKE) debug

%.o: %.c $(IDDAWC_LIBRARY) static_compressed_inmemory_website_callback.h static_compressed_inmemory_website_callback.c http_compression_callback.h http_compression_callback.c idwcc.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $<

idwcc: $(OBJECTS)
	$(CC) -o $@ $^ $(LIBS) $(LDFLAGS)

install: idwcc
	mkdir -p $(DESTDIR)/bin $(DESTDIR)/man/man1/ $(DESTDIR)/share/idwcc/
	install -m755 idwcc $(DESTDIR)/bin
	install -m644 idwcc.1 $(DESTDIR)/man/man1/
	cp -R webapp/ $(DESTDIR)/share/idwcc/

uninstall:
	rm -f $(DESTDIR)/bin/idwcc $(DESTDIR)/man/man1/idwcc.1 $(DESTDIR)/share/idwcc/

test: idwcc
	LD_LIBRARY_PATH=$(IDDAWC_LOCATION): ./idwcc -w webapp

memcheck: debug
	LD_LIBRARY_PATH=$(IDDAWC_LOCATION): $(VALGRIND_COMMAND) ./idwcc -w webapp 2>valgrind.txt

manpage: idwcc
	help2man ./idwcc -s 1 -n "OAuth2/OIDC client program to test or validate OAuth2/OIDC AS." > idwcc.1

iddawc-dev-full_$(IDDAWC_VERSION)_alpine_$(ALPINE_VERSION)_x86_64.tar.gz:
	wget https://github.com/babelouest/iddawc/releases/download/v${IDDAWC_VERSION}/iddawc-dev-full_$(IDDAWC_VERSION)_alpine_$(ALPINE_VERSION)_x86_64.tar.gz

docker-build: iddawc-dev-full_$(IDDAWC_VERSION)_alpine_$(ALPINE_VERSION)_x86_64.tar.gz
	docker build -t babelouest/idwcc:$(IDDAWC_VERSION) --build-arg IDDAWC_VERSION=$(IDDAWC_VERSION) --build-arg ALPINE_VERSION=$(ALPINE_VERSION) .
	docker tag babelouest/idwcc:$(IDDAWC_VERSION) babelouest/idwcc:latest

docker-run:
	docker run -it --rm -p 4398:4398 babelouest/idwcc:latest

=== debian/changelog ===
iddawc (1.1.6-1) unstable; urgency=medium

  * New upstream release
  * d/control: Update standards version to 4.6.1 (no change)
  * d/control: fix idwcc build by installing js libs in Build-Depends
  * lintian-overrides: ignore false positives

 -- Nicolas Mora <babelouest@debian.org>  Mon, 22 Aug 2022 07:54:29 -0400

iddawc (1.1.4-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <babelouest@debian.org>  Sun, 05 Jun 2022 08:03:32 -0400

iddawc (1.1.3-1) unstable; urgency=medium

  * New upstream release
  * d/tests: Update unit-test

 -- Nicolas Mora <babelouest@debian.org>  Mon, 25 Apr 2022 19:27:34 -0400

iddawc (1.1.2-2) unstable; urgency=medium

  * d/patches: re-enable test.patch

 -- Nicolas Mora <babelouest@debian.org>  Thu, 14 Apr 2022 21:29:37 -0400

iddawc (1.1.2-1) unstable; urgency=medium

  * New upstream release
  * d/copyright: update years
  * d/libiddawc1.1.symbols: update symbols
  * d/patches remove patches

 -- Nicolas Mora <babelouest@debian.org>  Mon, 11 Apr 2022 10:21:13 -0400

=== debian/control ===
Source: iddawc
Section: devel
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Nicolas Mora <babelouest@debian.org>
Build-Depends: debhelper-compat (= 13)
             , liborcania-dev
             , libyder-dev
             , libulfius-dev
             , librhonabwy-dev
             , libgnutls28-dev
             , libjansson-dev
             , zlib1g-dev
             , cmake
             , pkg-config
             , check
             , doxygen
             , gnutls-bin
             , fonts-fork-awesome
             , libjs-jquery
             , libjs-bootstrap4
             , libjs-popper.js
Standards-Version: 4.6.1
Homepage: https://github.com/babelouest/iddawc
Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/iddawc
Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/iddawc.git
Rules-Requires-Root: no

Package: libiddawc1.1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libiddawc0.9 (<< 0.9.8-2)
Replaces: libiddawc0.9 (<< 0.9.8-2)
Description: OAuth2 and OIDC client library
 Handles the OAuth2 and OpenID Connect authentication process flow from the
 client side.
 .
  - Generates requests based on input parameters
  - Parses response
  - Validates response values

Package: libiddawc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libiddawc1.1 (= ${binary:Version}), ${misc:Depends}
       , liborcania-dev
       , libyder-dev
       , libulfius-dev
       , librhonabwy-dev
       , libgnutls28-dev
       , libjansson-dev
       , zlib1g-dev
Description: OAuth2 and OIDC client library - development
 Handles the OAuth2 and OpenID Connect authentication process flow from the
 client side.
 .
  - Generates requests based on input parameters
  - Parses response
  - Validates response values
 .
 This package contains the development files.

Package: idwcc
Architecture: any
Depends: ${shlibs:Depends}
       , ${misc:Depends}
       , libiddawc1.1 (= ${binary:Version})
       , fonts-fork-awesome
       , libjs-jquery
       , libjs-bootstrap4
       , libjs-popper.js
Description: Client for OAuth2/OIDC AS configuration validation
 Provides a web application to be used as an OpenID Connect or OAuth2
 client.
 .
 Supports PKCE, token introspection, revocation, client registration,
 DPoP, Rich Authorization Request, Pushed Authorization Request,
 JWT Access tokens, encrypted tokens, requests and responses.

## iddawc 1.1.7

=== debian/changelog ===
iddawc (1.1.7-1) unstable; urgency=medium

  * New upstream release

 -- Nicolas Mora <babelouest@debian.org>  Sat, 15 Oct 2022 17:25:27 -0400

## iddawc 1.1.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,11 +30,11 @@
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/iddawc/issues")
 set(LIBRARY_VERSION_MAJOR "1")
 set(LIBRARY_VERSION_MINOR "1")
-set(LIBRARY_VERSION_PATCH "6")
-set(ORCANIA_VERSION_REQUIRED "2.3.0")
-set(YDER_VERSION_REQUIRED "1.4.17")
-set(ULFIUS_VERSION_REQUIRED "2.7.10")
-set(RHONABWY_VERSION_REQUIRED "1.1.8")
+set(LIBRARY_VERSION_PATCH "8")
+set(ORCANIA_VERSION_REQUIRED "2.3.2")
+set(YDER_VERSION_REQUIRED "1.4.19")
+set(ULFIUS_VERSION_REQUIRED "2.7.12")
+set(RHONABWY_VERSION_REQUIRED "1.1.10")
 
 set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
@@ -115,7 +115,7 @@
 
 add_library(iddawc SHARED ${LIB_SRC})
 set_target_properties(iddawc PROPERTIES
-        COMPILE_OPTIONS -Wextra
+        COMPILE_OPTIONS "-Wextra;-Wconversion"
         PUBLIC_HEADER "${INC_DIR}/iddawc.h;${PROJECT_BINARY_DIR}/iddawc-cfg.h"
         VERSION "${LIBRARY_VERSION}"
         SOVERSION "${LIBRARY_SOVERSION}")
@@ -163,20 +163,27 @@
     if (NOT ORCANIA_FOUND)
         if (DOWNLOAD_DEPENDENCIES)
             include(DownloadProject)
-            message(STATUS "Download Orcania ${ORCANIA_VERSION_REQUIRED}")
             download_project(PROJ orcania # ... otherwise, download archive
-                    URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_REQUIRED}.tar.gz"
-                    QUIET)
+                             URL "https://github.com/babelouest/orcania/archive/v${ORCANIA_VERSION_REQUIRED}.tar.gz"
+                             QUIET)
             add_subdirectory(${orcania_SOURCE_DIR} ${orcania_BINARY_DIR})
             include_directories(${orcania_SOURCE_DIR}/include)
-            add_dependencies(iddawc orcania)
+            include_directories(${orcania_BINARY_DIR})
+            add_dependencies(yder orcania)
             set(ORCANIA_LIBRARIES orcania)
+            set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})
+        else ()
+            message( FATAL_ERROR "Orcania not found")
+        endif ()
+    else()
+        if ("${ORCANIA_VERSION_STRING}" VERSION_GREATER_EQUAL "${ORCANIA_VERSION_REQUIRED}")
+            message(STATUS "Orcania found: ${ORCANIA_VERSION_STRING}")
+            set(LIBS ${LIBS} ${ORCANIA_LIBRARIES})
+            include_directories(${ORCANIA_INCLUDE_DIRS})
             include_directories(${orcania_BINARY_DIR})
         else ()
-            message( FATAL_ERROR "Orcania not found")
-        endif ()
-    else ()
-        include_directories(${ORCANIA_INCLUDE_DIRS})
+            message( FATAL_ERROR "Orcania version required: ${ORCANIA_VERSION_REQUIRED} - version installed: ${ORCANIA_VERSION_STRING}")
+        endif ()
     endif ()
 endif ()
 target_link_libraries(iddawc ${ORCANIA_LIBRARIES})
@@ -190,23 +197,28 @@
     if (NOT YDER_FOUND)
         if (DOWNLOAD_DEPENDENCIES)
             include(DownloadProject)
-            message(STATUS "Download Yder ${YDER_VERSION_REQUIRED}")
-            option(CHECK_ORCANIA "specific param" off)
             download_project(PROJ yder # ... otherwise, download archive
-                    URL "https://github.com/babelouest/yder/archive/v${YDER_VERSION_REQUIRED}.tar.gz"
-                    QUIET)
+                              URL "https://github.com/babelouest/yder/archive/v${YDER_VERSION_REQUIRED}.tar.gz"
+                              QUIET)
             add_subdirectory(${yder_SOURCE_DIR} ${yder_BINARY_DIR})
             include_directories(${yder_SOURCE_DIR}/include)
-            include_directories(${orcania_SOURCE_DIR}/include)
             add_dependencies(iddawc yder)
-            set(YDER_LIBRARIES yder)
+            set(YDER_LIBRARIES yder orcania)
             include_directories(${yder_BINARY_DIR})
         else ()
             message( FATAL_ERROR "Yder not found")
         endif ()
-    else ()
-        include_directories(${YDER_INCLUDE_DIRS})
-    endif ()
+    else()
+        if ("${YDER_VERSION_STRING}" VERSION_GREATER_EQUAL "${YDER_VERSION_REQUIRED}")
+            message(STATUS "Yder found: ${YDER_VERSION_STRING}")
+            set(LIBS ${LIBS} ${YDER_LIBRARIES})
+            include_directories(${YDER_INCLUDE_DIRS})
+            include_directories(${yder_BINARY_DIR})
+        else ()
+            message( FATAL_ERROR "Yder version required: ${YDER_VERSION_REQUIRED} - version installed: ${YDER_VERSION_STRING}")
+        endif ()
+    endif ()
+    target_link_libraries(iddawc ${LIBS} ${YDER_LIBRARIES})
 endif ()
 target_link_libraries(iddawc ${YDER_LIBRARIES})
 set(LIBS ${LIBS} ${YDER_LIBRARIES})
@@ -223,8 +235,8 @@
             option(CHECK_YDER "specific param" off)
             message(STATUS "Download Ulfius ${ULFIUS_VERSION_REQUIRED}")
             download_project(PROJ ulfius
-                    URL "https://github.com/babelouest/ulfius/archive/v${ULFIUS_VERSION_REQUIRED}.tar.gz"
-                    QUIET)
+                             URL "https://github.com/babelouest/ulfius/archive/v${ULFIUS_VERSION_REQUIRED}.tar.gz"
+                             QUIET)
             add_subdirectory(${ulfius_SOURCE_DIR} ${ulfius_BINARY_DIR})
             include_directories(${yder_SOURCE_DIR}/include)
             include_directories(${orcania_SOURCE_DIR}/include)
@@ -236,7 +248,14 @@
             message( FATAL_ERROR "Ulfius not found")
         endif ()
     else ()
-        include_directories(${ULFIUS_INCLUDE_DIRS})
+        if ("${ULFIUS_VERSION_STRING}" VERSION_GREATER_EQUAL "${ULFIUS_VERSION_REQUIRED}")
+            message(STATUS "Ulfius found: ${ULFIUS_VERSION_STRING}")
+            set(LIBS ${LIBS} ${ULFIUS_LIBRARIES})
+            include_directories(${ULFIUS_INCLUDE_DIRS})
+            include_directories(${yder_BINARY_DIR})
+        else ()
+            message( FATAL_ERROR "Ulfius version required: ${ULFIUS_VERSION_REQUIRED} - version installed: ${ULFIUS_VERSION_STRING}")
+        endif ()
     endif ()
 endif ()
 target_link_libraries(iddawc ${ULFIUS_LIBRARIES})
@@ -289,34 +308,3 @@
       include_directories(${ZLIB_INCLUDE_DIRS})
     endif ()
     add_executable(idwcc ${IDWCC_DIR}/idwcc.c ${INC_DIR}/iddawc.h ${IDWCC_DIR}/http_compression_callback.c ${IDWCC_DIR}/http_compression_callback.h ${IDWCC_DIR}/static_compressed_inmemory_website_callback.c ${IDWCC_DIR}/static_compressed_inmemory_website_callback.h ${PROJECT_BINARY_DIR}/iddawc-cfg.h)
-    set_target_properties(idwcc PROPERTIES SKIP_BUILD_RPATH TRUE)
-    add_dependencies(idwcc iddawc)
-    target_link_libraries(idwcc iddawc ${LIBS})
-    install(TARGETS idwcc RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
-    install(FILES ${IDWCC_DIR}/idwcc.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 COMPONENT runtime)
-    install(DIRECTORY ${IDWCC_DIR}/webapp/ DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/idwcc/webapp/ COMPONENT runtime)
-endif ()
-
-# documentation
-
-option(BUILD_IDDAWC_DOCUMENTATION "Build the documentation." OFF)
-if (BUILD_IDDAWC_DOCUMENTATION)
-    find_package(Doxygen)
-    if (DOXYGEN_FOUND)
-        set(doxyfile_in ${CMAKE_CURRENT_SOURCE_DIR}/doc/doxygen.cfg)
-        set(doxyfile ${CMAKE_CURRENT_BINARY_DIR}/doxyfile)
-        
-        configure_file(${doxyfile_in} ${doxyfile} @ONLY)
-        
-        add_custom_target(doc
-                          COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile_in}
-                          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
-                          COMMENT "Generating documentation with Doxygen"
-                          VERBATIM)
-
-    else ()
-        message(FATAL_ERROR "Doxygen is needed to build the documentation.")
-    endif ()
-endif ()
-
-# build iddawc-cfg.h file

=== Makefile ===
--- 
+++ 
@@ -34,7 +34,7 @@
 	cd $(LIBIDDAWC_LOCATION) && $(MAKE) clean
 	cd $(IDWCC_LOCATION) && $(MAKE) clean
 	cd $(TESTS_LOCATION) && $(MAKE) clean
-	rm -rf doc/html $(TESTS_LOCATION)/cert/*.crt $(TESTS_LOCATION)/cert/*.key $(TESTS_LOCATION)/cert/*.log
+	rm -rf doc/html/
 
 install:
 	cd $(LIBIDDAWC_LOCATION) && $(MAKE) install

=== src/Makefile ===
--- 
+++ 
@@ -30,14 +30,14 @@
 CONFIG_TEMPLATE=$(IDDAWC_INCLUDE)/iddawc-cfg.h.in
 DESTDIR=/usr/local
 CC=gcc
-CFLAGS+=-c -pedantic -std=gnu99 -fPIC -Wall -Werror -Wextra -D_REENTRANT -I$(IDDAWC_INCLUDE) $(ADDITIONALFLAGS) $(CPPFLAGS)
+CFLAGS+=-c -pedantic -std=gnu99 -fPIC -Wall -Werror -Wextra -Wconversion -D_REENTRANT -I$(IDDAWC_INCLUDE) $(ADDITIONALFLAGS) $(CPPFLAGS)
 LIBS=-L$(DESTDIR)/lib -lc -lulfius -lyder -lorcania -lrhonabwy -lgnutls -ljansson $(LDFLAGS)
 SONAME=-soname
 OBJECTS=iddawc.o
 OUTPUT=libiddawc.so
 VERSION_MAJOR=1
 VERSION_MINOR=1
-VERSION_PATCH=6
+VERSION_PATCH=8
 
 .PHONY: all clean

=== debian/changelog ===
iddawc (1.1.8-1) unstable; urgency=medium

  * New upstream release
  * d/control: Update Standards-Version to 4.6.2
  * d/copyright: Update copyright year to 2023 for debian/* files

 -- Nicolas Mora <babelouest@debian.org>  Wed, 11 Jan 2023 17:23:34 -0500

=== debian/control ===
--- 
+++ 
@@ -20,7 +20,7 @@
              , libjs-jquery
              , libjs-bootstrap4
              , libjs-popper.js
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/babelouest/iddawc
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/iddawc
 Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/iddawc.git

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1
# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
#export CTEST_PARALLEL_LEVEL = 1
#export CK_FORK = no

export CTEST_OUTPUT_ON_FAILURE=1

%:
	dh $@  --buildsystem=cmake --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -- $(ARGS) \
	                    -DSKIP_BUILD_RPATH=TRUE \
	                    -DBUILD_IDDAWC_TESTING=ON \
	                    -DINSTALL_HEADER=ON \
	                    -DDOWNLOAD_DEPENDENCIES=OFF \
	                    --no-warn-unused-cli

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	cd test && ./cert/create-cert.sh && cp -R cert/ ../build/
	cd build && $(MAKE) test -j1
endif

override_dh_auto_build:
	doxygen doc/doxygen.cfg
	cp /usr/share/javascript/jquery/jquery.min.js tools/idwcc/webapp/js
	cp /usr/share/javascript/popper.js/umd/popper.min.js tools/idwcc/webapp/js/
	cp /usr/share/javascript/popper.js/umd/popper-utils.min.js tools/idwcc/webapp/js/
	cp /usr/share/nodejs/bootstrap/dist/js/bootstrap.min.js tools/idwcc/webapp/js/
	cp /usr/share/nodejs/bootstrap/dist/js/bootstrap.min.js.map tools/idwcc/webapp/js/
	cp /usr/share/nodejs/bootstrap/dist/css/bootstrap.min.css tools/idwcc/webapp/css/
	cp /usr/share/nodejs/bootstrap/dist/css/bootstrap.min.css.map tools/idwcc/webapp/css/
	cp /usr/share/fonts-fork-awesome/css/fork-awesome.css tools/idwcc/webapp/css/
	cp /usr/share/fonts-fork-awesome/css/v5-compat.css tools/idwcc/webapp/css/
	cp /usr/share/fonts/eot/fork-awesome/forkawesome-webfont.eot tools/idwcc/webapp/fonts/
	cp /usr/share/fonts/svg/fork-awesome/forkawesome-webfont.svg tools/idwcc/webapp/fonts/
	cp /usr/share/fonts/truetype/fork-awesome/forkawesome-webfont.ttf tools/idwcc/webapp/fonts/
	cp /usr/share/fonts/woff/fork-awesome/forkawesome-webfont.woff tools/idwcc/webapp/fonts/
	cp /usr/share/fonts/woff/fork-awesome/forkawesome-webfont.woff2 tools/idwcc/webapp/fonts/
	dh_auto_build --

## iddawc 1.1.9%2Bds

=== Makefile ===
--- 
+++ 
@@ -22,6 +22,7 @@
 LIBIDDAWC_LOCATION=./src
 IDWCC_LOCATION=./tools/idwcc
 TESTS_LOCATION=./test
+EXAMPLE_LOCATION=./examples
 
 all:
 	cd $(LIBIDDAWC_LOCATION) && $(MAKE) $*
@@ -34,6 +35,7 @@
 	cd $(LIBIDDAWC_LOCATION) && $(MAKE) clean
 	cd $(IDWCC_LOCATION) && $(MAKE) clean
 	cd $(TESTS_LOCATION) && $(MAKE) clean
+	cd $(EXAMPLE_LOCATION) && $(MAKE) clean
 	rm -rf doc/html/
 
 install:
